// (c) Copyright 2013 Cloudera, Inc. All rights reserved.

define(["cloudera/common/charts/include/TimeSeriesUtil"],function(e){var t=function(e,t,n){return{timeSeriesData:e,numPoints:t,interpolationAlgorithm:n}};describe("TimeSeriesUtil Tests",function(){it("return the same array if already short",function(){var n=[{x:1,y:1},{x:2,y:2}],r=e.downSample(t(n,5,"linear"));expect(r).toEqual(n)}),it("throws an exception if algorithm is unknown",function(){var n=[{x:1,y:1},{x:2,y:2}];expect(function(){var r=e.downSample(t(n,1,"kaboom"))}).toThrow()}),it("throws an exception if numPoints is smaller than 0",function(){var n=[{x:1,y:1},{x:2,y:2}];expect(function(){var r=e.downSample(t(n,-1,"linear"))}).toThrow()}),it("returns an empty array if numPoints is zero",function(){var n=[{x:1,y:1},{x:2,y:2}],r=e.downSample(t(n,0,"linear"));expect(r).toEqual([])}),it("culls duplicated points",function(){var n=[{x:1,y:1}],r;for(r=0;r<100;r++)n.push({x:10,y:1});var i=e.downSample(t(n,50,"linear"));expect(i.length).toEqual(2),expect(i[0]).toEqual({x:1,y:1}),expect(i[1]).toEqual({x:10,y:1})}),it("should downSample linearly",function(){var n=[],r,i=1e3/99,s;for(r=1;r<=1001;r++)n.push({x:r,y:r*10});var o=e.downSample(t(n,100,"linear"));expect(o.length).toEqual(100),expect(o[0]).toEqual({x:1,y:10}),expect(o[98]).toEqual({x:990,y:9900}),expect(o[99]).toEqual({x:1001,y:10010});for(r=1;r<99;r++)s=1+parseInt(r*i,10),expect(o[r].x).toEqual(s),expect(o[r].y).toEqual(s*10)}),it("should handle NaN correctly",function(){var n=[],r,i=1e3/99,s;for(r=1;r<=1001;r++)n.push({x:r,y:"NaN"});var o=e.downSample(t(n,100,"linear"));expect(o.length).toEqual(100),expect(o[0]).toEqual({x:1,y:0,originalY:"NaN"}),expect(o[98]).toEqual({x:990,y:0,originalY:"NaN"}),expect(o[99]).toEqual({x:1001,y:0,originalY:"NaN"});for(r=1;r<99;r++)s=1+parseInt(r*i,10),expect(o[r].x).toEqual(s),expect(o[r].y).toEqual(0),expect(o[r].originalY).toEqual("NaN")}),it("should throw if generateSamplePoints is passed bad arguments",function(){expect(function(){e.generateSamplePoints(null,1,1)}).toThrow(),expect(function(){e.generateSamplePoints(1,null,1)}).toThrow(),expect(function(){e.generateSamplePoints(1,1,null)}).toThrow(),expect(function(){e.generateSamplePoints(1,100,1)}).toThrow(),expect(function(){e.generateSamplePoints(100,100,5)}).toThrow(),expect(function(){e.generateSamplePoints(101,100,5)}).toThrow(),expect(function(){e.generateSamplePoints(101,103,5)}).toThrow()}),it("should generate the right number of x points at the right time",function(){var t=e.generateSamplePoints(1,1001,100);expect(t.length).toEqual(100),expect(t[0]).toEqual(1),expect(t[98]).toEqual(990),expect(t[99]).toEqual(1001)}),it("sample should throw with bad arguments",function(){expect(function(){e.sample([{x:1,y:1}],[1,2],"kaboom")}).toThrow(),expect(function(){e.sample(null,[1,2],"linear")}).toThrow(),expect(function(){e.sample([{x:1,y:1}],null,"linear")}).toThrow()}),it("sample should return an empty arry if data or sample points are empty",function(){expect(e.sample([],[1,2],"linear")).toEqual([]),expect(e.sample([{x:1,y:1}],[],"linear")).toEqual([])}),it("sample should return a constant stream for a single point",function(){var t=e.generateSamplePoints(1,1001,100),n=e.sample([{x:1,y:1}],t,"linear"),r;expect(n.length).toEqual(100);for(r=0;r<100;r++)expect(n[r].x).toEqual(t[r]),expect(n[r].y).toEqual(1);n=e.sample([{x:1,y:"NaN"}],t,"linear"),expect(n.length).toEqual(100);for(r=0;r<100;r++)expect(n[r].x).toEqual(t[r]),expect(n[r].y).toEqual(0),expect(n[r].originalY).toEqual("NaN")}),it("sample returns an array with same data if sampling to similar samples",function(){var t=e.generateSamplePoints(1,1001,100),n=[],r;for(r=0;r<100;++r)n.push({x:t[r],y:t[r]*10});var i=e.sample(n,t,"linear");expect(i.length).toEqual(100);for(r=0;r<100;r++)expect(i[r].x).toEqual(t[r]),expect(i[r].y).toEqual(t[r]*10)}),it("sample should interpolate correctly",function(){var t=e.generateSamplePoints(1,1001,100),n=[],r;n.push({x:1,y:1},{x:2,y:2});var i=e.sample(n,t,"linear");expect(i.length).toEqual(100);for(r=0;r<100;r++)expect(i[r].x).toEqual(t[r]),expect(i[r].y).toEqual(t[r]);n=[],n.push({x:1,y:1},{x:500,y:500},{x:750,y:250}),i=e.sample(n,t,"linear"),expect(i.length).toEqual(100);for(r=0;r<100;r++)expect(i[r].x).toEqual(t[r]),r<50?expect(i[r].y).toEqual(t[r]):expect(i[r].y).toEqual(1e3-t[r])})})})